require "prefabutil"

local assets =
{
    Asset("ANIM", "anim/critterlab.zip"),
   	Asset("IMAGE", "minimap/critterlab.tex"),
        Asset("ATLAS", "minimap/critterlab.xml"), 
}

local function blink(inst)
    inst.AnimState:PlayAnimation("proximity_loop"..math.random(4))
	inst.idletask = inst:DoTaskInTime(math.random() + 1.0, blink)
end

local function onturnoff(inst)
	if inst.idletask ~= nil then
		inst.idletask:Cancel()
		inst.idletask = nil
	end
    inst.AnimState:PushAnimation("idle", false)
	inst.SoundEmitter:KillSound("loop")
end

local function onturnon(inst)
	inst.SoundEmitter:PlaySound("critterslab/music/idle", "loop")
	blink(inst)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddSoundEmitter()

    MakeObstaclePhysics(inst, .4)

    inst.MiniMapEntity:SetPriority(5)
    inst.MiniMapEntity:SetIcon("critterlab.tex") 

    inst.AnimState:SetBank("critterlab")
    inst.AnimState:SetBuild("critterlab")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("prototyper")
    inst:AddTag("critterlab")
    
	MakeSnowCovered(inst, .01) 

    inst:AddComponent("inspectable")
    
    inst:AddComponent("prototyper")  
    inst.components.prototyper.onturnon = onturnon
    inst.components.prototyper.onturnoff = onturnoff
    inst.components.prototyper.trees = TUNING.PROTOTYPER_TREES.CRITTERLAB_MOD  

    return inst
end

return Prefab("critterlab", fn, assets)
