require("stategraphs/commonstates")
require("stategraphs/SGcritter_common")

local actionhandlers = 
{
}

local events=
{
	SGCritterEvents.OnSleepEx(),
	SGCritterEvents.OnWakeEx(),
	SGCritterEvents.OnEat(),

    CommonHandlers.OnLocomote(false,true),
}

local states=
{
}

local states =
{
}

local function StartFlapping(inst)
    --inst.SoundEmitter:PlaySound("glomling/music/fly", "flying")
    inst.SoundEmitter:PlaySound("glomling/music/fly")
end

local function RestoreFlapping(inst)
    if not inst.SoundEmitter:PlayingSound("flying") then
        StartFlapping(inst)
    end
end

local function StopFlapping(inst)
    inst.SoundEmitter:KillSound("flying")
end
--[[
local function StartFlap(inst)
	if inst.FlapTask then return end
	inst.FlapTask = inst:DoPeriodicTask(4*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/fly") end)
end

local function StopFlapping(inst)
	if inst.FlapTask then
		inst.FlapTask:Cancel()
		inst.FlapTask = nil
	end
end
--]]
local emotes =
{
	{ anim="emote1",
      timeline=
		{
			TimeEvent(17*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/bounce_voice") end),
		},
	},
	{ anim="emote2",
      timeline=
		{
            TimeEvent(7*FRAMES, StopFlapping),
			TimeEvent(11*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/bounce_ground") end),
			TimeEvent(13*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/bounce_ground") end),
			TimeEvent(15*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/emote_2") end),
            TimeEvent(68*FRAMES, StartFlapping),
		},
      fns=
        {
            onexit = RestoreFlapping,
        },
	},
}

SGCritterStates.AddIdle(states, #emotes)
SGCritterStates.AddEmotes(states, emotes)
SGCritterStates.AddEat(states,
        {
           TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/bounce_ground") end),
           TimeEvent(4*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/bounce_voice") end),

            TimeEvent(22*FRAMES, StopFlapping),

            TimeEvent((26+8)*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/eat") end),
            TimeEvent((26+22)*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/eat") end),

            TimeEvent(74*FRAMES, StartFlapping),
        },
        {
            onexit = RestoreFlapping,
        })
SGCritterStates.AddHungry(states,
        {
            TimeEvent(14*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/vomit_voice") end),
            TimeEvent(24*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/vomit_voice") end),
            TimeEvent(36*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/vomit_voice") end),
        })
SGCritterStates.AddNuzzle(states, actionhandlers,
		{
            TimeEvent(6*FRAMES, function(inst)
                StopFlapping(inst)
               inst.SoundEmitter:PlaySound("glomling/music/bounce_ground")
            end),
            TimeEvent(53*FRAMES, StartFlapping),
        },
        {
            onexit = RestoreFlapping,
        })
CommonStates.AddWalkStates(states, nil, nil, true)

local function CleanupIfSleepInterrupted(inst)
    if not inst.sg.statemem.continuesleeping then
        RestoreFlapping(inst)
    end
end
SGCritterStates.AddSleepExStates(states,
		{
			starttimeline = 
			{
				TimeEvent(35*FRAMES, function(inst)
                    StopFlapping(inst)
                    --inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/together/glomling/bounce_ground")
                end),
			},
			sleeptimeline = 
			{
				TimeEvent(41*FRAMES, function(inst) inst.SoundEmitter:PlaySound("glomling/music/sleep") end),
			},
            endtimeline =
            {
                TimeEvent(12 * FRAMES, StartFlapping),
            },
        },
        {
            onexitsleep = CleanupIfSleepInterrupted,
            onexitsleeping = CleanupIfSleepInterrupted,
            onexitwake = RestoreFlapping,
            onwake = StopFlapping,
        })

return StateGraph("SGcritter_glomling", states, events, "idle", actionhandlers)

