require("stategraphs/commonstates")
require("stategraphs/SGcritter_common")

local actionhandlers = 
{
}
local events=
{
	SGCritterEvents.OnSleepEx(),
	SGCritterEvents.OnWakeEx(),
	SGCritterEvents.OnEat(),

    CommonHandlers.OnLocomote(false,true),
}

local states=
{
}
local emotes =
{
    {
        anim = "emote1",
        timeline =
        {
            --TimeEvent(11*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/walk") end),
        },
    },
    {
        anim = "emote2",
        timeline =
        {
            --TimeEvent(3*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/nuzzle") end),
            --TimeEvent(5*FRAMES, PlayFootstep),
            --TimeEvent(18*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/nuzzle") end),
            --TimeEvent(19*FRAMES, PlayFootstep),
            --TimeEvent(25*FRAMES, PlayFootstep),
            --TimeEvent(31*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/nuzzle") end),
            --TimeEvent(33*FRAMES, PlayFootstep),
        },
    },
}
SGCritterStates.AddIdle(states, #emotes)
SGCritterStates.AddEmotes(states, emotes)

SGCritterStates.AddEat(states,
    {
        --TimeEvent(4*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/eat_pre") end),
    })
SGCritterStates.AddHungry(states,
    {
        --TimeEvent(12*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/rooster/distress_long") end),
    })
SGCritterStates.AddNuzzle(states, actionhandlers,
    {
       -- TimeEvent(8*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/nuzzle") end),
    })
        
CommonStates.AddWalkStates(states,
    {
        walktimeline =
        {
            --TimeEvent(2*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/walk") end),
            TimeEvent(15*FRAMES, PlayFootstep),
        },
   }, nil, true)

SGCritterStates.AddSleepExStates(states,
    {
        starttimeline =
        {
            --TimeEvent(3*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/sleep_pre") end),
        },
        sleeptimeline =
        {
            --TimeEvent(5*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/sleep_in") end),
            --TimeEvent(20*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/together/perdling/sleep_out") end),
        },
    })

return StateGraph("SGcritter_perdling", states, events, "idle", actionhandlers)